<!-- 
  Copyright (c) 2022 Sitekit Systems Ltd t/a Condatis. All rights reserved.
  Licensed under the MIT license. See LICENSE file in the project root for full license information.
-->

<TrustFrameworkPolicy
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns="http://schemas.microsoft.com/online/cpim/schemas/2013/06"
  PolicySchemaVersion="0.3.0.0"
  TenantId="#{Policy.B2C.TenantDomain}#"
  PolicyId="#{Policy.PolicyId.SignIn.Saml}#"
  PublicPolicyUri="#{Policy.PublicPolicyUri}#/#{Policy.PolicyId.SignIn.Saml}#"
  DeploymentMode="#{Policy.DeploymentMode}#"
  UserJourneyRecorderEndpoint="urn:journeyrecorder:applicationinsights">
  <BasePolicy>
    <TenantId>#{Policy.B2C.TenantDomain}#</TenantId>
    <PolicyId>#{Policy.PolicyId.SignIn.Oidc}#</PolicyId>
  </BasePolicy>

  <ClaimsProviders>
    <ClaimsProvider>
      <DisplayName>SAML Token Issuer</DisplayName>
      <TechnicalProfiles>
        <!-- SAML Token Issuer technical profile -->
        <TechnicalProfile Id="SamlAssertionIssuer">
          <DisplayName>Token Issuer</DisplayName>
          <Protocol Name="SAML2"/>
          <OutputTokenFormat>SAML2</OutputTokenFormat>
          <Metadata>
            <Item Key="IssuerUri">#{Policy.B2C.TenantUrl}#/#{Policy.PolicyId.SignIn.Saml}#</Item>
            <Item Key="XmlSignatureAlgorithm">Sha256</Item>
          </Metadata>
          <CryptographicKeys>
            <Key Id="MetadataSigning" StorageReferenceId="B2C_1A_SamlSigningKey"/>
            <Key Id="SamlAssertionSigning" StorageReferenceId="B2C_1A_SamlSigningKey"/>
            <Key Id="SamlMessageSigning" StorageReferenceId="B2C_1A_SamlSigningKey"/>
          </CryptographicKeys>
          <InputClaims/>
          <OutputClaims/>
          <UseTechnicalProfileForSessionManagement ReferenceId="SM-SAML-Issuer"/>
        </TechnicalProfile>

        <TechnicalProfile Id="SM-SAML-Issuer">
          <DisplayName>Session Management Provider</DisplayName>
          <Protocol Name="Proprietary" Handler="Web.TPEngine.SSO.SamlSSOSessionProvider, Web.TPEngine, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null" />
        </TechnicalProfile>
      </TechnicalProfiles>
    </ClaimsProvider>
  </ClaimsProviders>

  <UserJourneys>
    <UserJourney Id="SignIn">
      <OrchestrationSteps>        
        <!-- Send claims -->
        <OrchestrationStep Order="4" Type="SendClaims" CpimIssuerTechnicalProfileReferenceId="SamlAssertionIssuer" />
      </OrchestrationSteps>
    </UserJourney>
  </UserJourneys>

  <RelyingParty>
    <DefaultUserJourney ReferenceId="SignIn"/>
    <UserJourneyBehaviors>
      <SingleSignOn Scope="Tenant" />
      <JourneyInsights TelemetryEngine="ApplicationInsights" InstrumentationKey="#{ApplicationInsights.InstrumentationKey}#" DeveloperMode="#{Policy.DebugMode}#" ClientEnabled="false" ServerEnabled="true" TelemetryVersion="1.0.0" />
      <ContentDefinitionParameters>
        <Parameter Name="app">{OIDC:ClientId}</Parameter>
      </ContentDefinitionParameters>
      <ScriptExecution>Allow</ScriptExecution>
    </UserJourneyBehaviors>
    <TechnicalProfile Id="PolicyProfile">
      <DisplayName>PolicyProfile</DisplayName>
      <Protocol Name="SAML2"/>
      <Metadata>
        <Item Key="XmlSignatureAlgorithm">Sha256</Item>
      </Metadata>
      <OutputClaims>
        <OutputClaim ClaimTypeReferenceId="objectId" PartnerClaimType="sub" />
        <OutputClaim ClaimTypeReferenceId="signInEmail" PartnerClaimType="email" />
        <OutputClaim ClaimTypeReferenceId="givenName" />
        <OutputClaim ClaimTypeReferenceId="surname" />
        <OutputClaim ClaimTypeReferenceId="displayName" />
        <OutputClaim ClaimTypeReferenceId="extension_referrer" PartnerClaimType="referrer" />
      </OutputClaims>
      <SubjectNamingInfo ClaimType="sub" Format="urn:oasis:names:tc:SAML:2.0:nameid-format:persistent" ExcludeAsClaim="true" />
    </TechnicalProfile>
  </RelyingParty>
</TrustFrameworkPolicy>